scriptName "TEST_drawUnitVehicleIcons";

diag_log _this;

private _ctrlEventHandler = _this select 0;
private _control = _ctrlEventHandler select 0;

_allActiveInfantry = (allUnits + allDeadMen) select {simulationEnabled _x && !isObjectHidden _x};

if (is3DENPreview) then
{
	_allActiveInfantry = allUnits + allDeadMen;
};

_allActiveVehicles = (entities [["AllVehicles"],["Man","SoundSetSource_01_base_F"],false,false]) select {simulationEnabled _x && !isObjectHidden _x};

if (is3DENPreview) then
{
	_allActiveVehicles = (entities [["AllVehicles"],["Man","SoundSetSource_01_base_F"],false,false]);
};

TEST_fnc_drawMapIcons =
{
	params ["_entities","_isInfantry"];

	{
		_unit = _x;

		_exit = false;

		if (_isInfantry) then
		{
			if ((vehicle _unit) isNotEqualTo _unit) then {_exit = true;};
		}
		else
		{
			if (({alive _x} count (crew _unit)) == 0) then {_exit = true;};
		};

		if (!(_exit)) then
		{
			if (!(alive _unit)) then
			{
				_timeOfDeath = _unit getVariable ["TEST_TimeOfDeath",-1];

				if (_timeOfDeath == -1) then {_unit setVariable ["TEST_TimeOfDeath",time];};

				if (time > (_timeOfDeath + 10)) then
				{
					_exit = true;
				};
			};
		};

		if (_exit) then
		{
			continue
		};

		_sideUnit = side _unit;//if (isNull (group _unit)) then {side _unit} else {side (group _unit)};

		if ((_sideUnit != playerSide) && {((player knowsAbout _unit) < 1.6) && {(!(is3DENPreview))}}) then
		{
			continue
		};

		_color = if (alive _unit) then
		{
			if (!(captive _unit)) then
			{
				switch (_sideUnit) do
				{
					case west:		{TEST_ColorBlue};
					case east:		{TEST_ColorRed};
					case resistance:	{TEST_ColorGreen};
					case civilian:		{TEST_ColorOrange};
					default			{TEST_ColorWhite};
				};
			}
			else
			{
				TEST_ColorWhite
			};
		}
		else
		{
			TEST_ColorBlack
		};

		_unitIcon = getText (configFile/"cfgVehicles"/(typeOf _unit)/"icon");

		_iconSize = 20;

		_alpha = 0;

		if ((playerSide getFriend (side _unit)) >= 0.6) then
		{
			if (TEST_ShowFriendlyMapMarkers) then
			{
				_alpha = 1;
			};
		}
		else
		{
			if (TEST_ShowEnemyMapMarkers) then
			{
				_alpha = if (is3DENPreview) then
				{
					1
				}
				else
				{
					(playerSide knowsAbout _unit)/4
				};
			};
		};

		_color set [3,_alpha];

		if (_unit isEqualTo player) then
		{
			_color = getArray (configFile >> "CfgInGameUI" >> "IslandMap" >> "colorMe");
			_unitIcon = getText (configFile >> "CfgInGameUI" >> "IslandMap" >> "iconPlayer");
		};

		_position = getPosASL _unit;
		_direction = getDir _unit;

		_text = "";

		_control drawIcon
		[
			_unitIcon,
			_color,
			_position,
			_iconSize,
			_iconSize,
			_direction,
			_text,
			2//outline (works for text and for icon only if icon angle is 0)
		];
	} forEach _entities;
};

[_allActiveInfantry,true] call TEST_fnc_drawMapIcons;

[_allActiveVehicles,false] call TEST_fnc_drawMapIcons;

